=== repositories/kraft/package/debian/changelog ===
unikraft-tools (0.4.0) unstable; urgency=medium

  * kraft v0.4.0 released
  * xen-guest: When debugging, do not exit on guest shutdown
  * run/qemu-guest: Remove PMU option from CPU feature flags
  * qemu-guest: When debugging, do not exit on guest shutdown
  * package: Move Dockerfiles to package/ directory.
  * make: Build from any directory.
  * kraft: perform pre-initialisation of platform cache.
  * kraft: Update README.md with information redirection.
  * kraft: Update MAINTAINERS list
  * kraft: Update Github URL.
  * kraft: Set UK_APPS environment default
  * kraft: Remove reference to volumes and networks (for now).
  * kraft: Remove reference to volumes and networks (for now).
  * kraft: Remove --workdir flag
  * kraft: Provide specification file choice order.
  * kraft: Provide more coherent build for Docker
  * kraft: Provide full context subcomponents.
  * kraft: Provide details on influential environmental variables.
  * kraft: Provide ability to not checkout a repository.
  * kraft: Provide a central constants file.
  * kraft: Projet serialization
  * kraft: Introduce `volume` and `network` directives and increase
    stability.
  * kraft: Introduce `run` directive in specification.
  * kraft: Include full environment in all exec calls.
  * kraft: Include MANIFEST.in to include specification JSON files.
  * kraft: Fix setting defconf Kconfig value for non object directives.
  * kraft: Fix missing gitdb dependency.
  * kraft: Fix missing gitdb dependency with GitPython upgrade
  * kraft: Fix missing constant in config.
  * kraft: Fix missing Click option type for mutually exclusive types.
  * kraft: Fix is_configured to return True.
  * kraft: Consolidate project constants.
  * kraft: Consolidate list/update.
  * kraft:  Introduce YAML specification system.
  * kraft/utils: Fix missing import.
  * kraft/utils: Do not fail for file duplication on recursive copies.
  * kraft/update: Re-introduce Kraft update command.
  * kraft/update: Actually perform a forced update
  * kraft/settings:  Introduce .kraftrc
  * kraft/scripts:  Introduce new kraft-net network helper and dir
    rename.
  * kraft/repository: Turn logger warning into debug.
  * kraft/repository: Sort version numbers before chosing latest
    release.
  * kraft/repository: Return the latest version of the repository.
  * kraft/repository: Handle potentially corrupt Git repositories.
  * kraft/repository: Handle inability to perform fetch.
  * kraft/repository: Fix recursion error and pre-emptive checkout
  * kraft/project: handle missing kraft.yaml file during init
  * kraft/project: Provide Unikraft make P flag for alt platform builds.
  * kraft/project: Idiomize method name.
  * kraft/project: Force fetch and prepare for all builds.
  * kraft/project: Fix ensure checkout before configure.
  * kraft/executor: Use push arguments to platform executors.
  * kraft/executor: Support qemu-guest architectures.
  * kraft/executor: Only use -t flags for QEMU.
  * kraft/executor: Fix executor extra arg appends.
  * kraft/executor: Fix command variable mapping.
  * kraft/executor: Extract archives into temp directories.
  * kraft/executor: Enable guest acceleration if host architeture does
    not match target architecture.
  * kraft/errors: Anglicised target architecture/platform mismatch
    errors.
  * kraft/docs: Update README with kraft --help.
  * kraft/docs: Accept current changes.
  * kraft/context: Correct default apps directory.
  * kraft/config: Fix infering library Kconfig name.
  * kraft/components: Provide a mechanic to retrieve the shortest
    version of a repository source.
  * kraft/components/volume: Save workdir.
  * kraft/components/repository: update known versions for all repo
    types
  * kraft/components/repository: Fix missing exception import.
  * kraft/components/repository: Fix against listing truly empty
    repositories.
  * kraft/components/network: Account for varying brctl outputs.
  * kraft/components/executor: Fix map final arguments into string.
  * kraft/components/executor: Fix map final arguments into string.
  * kraft/components/executor: Extract tarball 9pfs.
  * kraft/components/executor: Do not escape xen/qemu-guest arguments.
  * kraft/commands: Remove  command from source tree.
  * kraft/commands: Re-introduce kraft-list command.
  * kraft/commands: Prompt user for configuration override.
  * kraft/commands: Pass --dbg or -d for non-stripped unikernel.
  * kraft/commands: Introduce run command.
  * kraft/commands: Import DHCP server initializer in correct file.
  * kraft/commands: Fix broken subcommand invocation.
  * kraft/commands: Exit on failure.
  * kraft/commands/update: Update kraft repsitory location.
  * kraft/commands/up: Remove old dnsmasq options.
  * kraft/commands/up: Provide blank up command.
  * kraft/commands/up: Introducing `kraft up`
  * kraft/commands/up: Introduce template for  command.
  * kraft/commands/up: Clean up comments.
  * kraft/commands/run: Add help to platform option.
  * kraft/commands/run: Add help to platform option.
  * kraft/commands/run:  Provide choice listing for architecture and
    platform.
  * kraft/commands/list: Text and commenting.
  * kraft/commands/list: Option to display list as JSON.
  * kraft/commands/list: Fix wording.
  * kraft/commands/list:  Prefer to update if cache is stale.
  * kraft/commands/init: Intrduce init command.
  * kraft/commands/init: Fix template app and usage.
  * kraft/commands/init: Fix logic to determine preferred architecture
    or platform.
  * kraft/commands/init: Determine app name from directory if omitted.
  * kraft/commands/configure: Validate architecture and platform.
  * kraft/commands/configure: Rename menuconfig short flag to -k.
  * kraft/commands/configure: Remove statically known platforms.
  * kraft/commands/configure: Fix extra print.
  * kraft/commands/configure: Fix architecture and platform selection.
  * kraft/commands/configure: Do not prompt check for menuconfig.

